/// <reference path="../services/route-services.js" />
var app = app || {};
app.Controlers = (function (app) {

    var ERROR_CODES = {
        invalid_key: '(1)',
        no_internet: '(2)',
        invalid_manifest: '(3)',
        server_connection_error: '(4)',
        unspecified_error: '(5)'
    };


    var URL_PARAMETER = 'showError',
        WRAPPER_ID = 'splashTroubleshootWrapper';

    if(!app.Controlers) {
        app.Controlers = {};
    }

    var instance = {};

    instance.getWrapperId = function () {
        return WRAPPER_ID;
    };

    instance.getWrapperClass = function () {
        var wrapperClass = "borealis";
        var params = app.RouteServices.getParams();
        for (var i = 0; i < params.length; i++) {
            if (params[i].name == "skinid") {
                switch (params[i].value) {
                    case "ForYou_JAC":
                        wrapperClass = "foryou";
                        break;
                    case "JVC":
                        wrapperClass = "jvc";
                        break;
                    case "KENWOOD":
                        wrapperClass = "kenwood";
                        break;
                    default:
                        wrapperClass = "borealis";
                        break;
                }
            }
        }
        return wrapperClass;
    };

    instance.initPage = function(paramValue) {
                  console.log("init page!");
        if(paramValue) {
            if (paramValue.toLocaleLowerCase() === "no_internet" || paramValue.toLocaleLowerCase() === "server_connection_error") {
                document.getElementById('iconRefresh').style.display = 'block';
            } else {
                document.getElementById('iconRefresh').style.display = 'none';
            }
            var errorCode = paramValue.toLowerCase();
            app.LocalisationService.getMessage('error_loading_apps', function (message) {
                document.getElementById('errorLoadingApps').innerHTML = message;
            });

            app.LocalisationService.getMessage(errorCode, function(errorMessage) {
                if(errorMessage){
                    if (['host_needs_update', 'host_needs_update_ios', 'host_needs_update_android', 'no_internet', 'server_connection_error'].indexOf(errorCode) >= 0) {
                        document.getElementById('errorMessage').innerHTML = errorMessage;
                    } else {
                        app.LocalisationService.getMessage('error_code', function (errorCodeText) {
                            document.getElementById('errorMessage').innerHTML = errorCodeText.replace("<#>", ERROR_CODES[paramValue.toLowerCase()] + "&rlm;");
                        });
                    }
                }
            })
        }
    };

    app.Controlers[URL_PARAMETER.toLowerCase()] = instance;

    return app.Controlers;
})(app);
