var LocalizationService = (function () {
    var ON_CHANGE_SETTINGS_EVENT_NAME = WebLinkService.getOnChangeSettingsEventName();
    var ROUTE_TO_LOCALES = './locales/';
    var LICENSE_AGREEMENT_HTML_NAME = '/LicenseAgreement.html';
    var DEFAULT_LANGUAGE = 'en';
    var language;

    WebLinkService.getWebLinkObjectsPromise()
        .then(function () {
            language = WebLink.info.getSettings().language;
        });

    function loadLicenseDocument() {
        return WebLinkService.getWebLinkObjectsPromise()
            .then(function () {
                return makeRequest(language)
            })
            .catch(function () {
                language = DEFAULT_LANGUAGE;
                return makeRequest(language);
            });
    }

    function makeRequest(lang) {
        return new Promise(function (resolve, reject) {
            var href = ROUTE_TO_LOCALES + lang + LICENSE_AGREEMENT_HTML_NAME;

            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function () {
                if (this.readyState === 4) {
                    if (this.status === 200 || this.status === 0) {
                        resolve(this.responseText);
                    }
                    if (this.status === 404) {
                        reject()
                    }
                }
            };

            xhttp.open("GET", href, true);
            xhttp.send();
        });
    }

    function onLanguageChange(callback) {
        document.addEventListener(ON_CHANGE_SETTINGS_EVENT_NAME, function (ev) {
            if (ev.detail && ev.detail.language) {
                if (ev.detail.language !== language) {
                    language = ev.detail.language;
                    loadLicenseDocument()
                        .then(function (result) {
                            callback(result)
                        });
                }
            }
        });
    }

    return {
        loadLicenseDocument: loadLicenseDocument,
        onLanguageChange: onLanguageChange
    }
})();
