
(function () {
    var checkForWebLinkObject = setInterval(function () {
        if (window.WebLink !== undefined && window.WebLink.info !== undefined) {
            clearInterval(checkForWebLinkObject);
            var DEFAULT_LANGUAGE = "en";
            var DEFAULT_ERROR = "error_in_app";
            var WL_LANGUAGE_CHANGE_EVENT_NAME = "languangeChange";
            WebLink.info.setOnChangeSettingEventName(WL_LANGUAGE_CHANGE_EVENT_NAME);

            function getErrorCode() {
                var parameterString = decodeURIComponent(window.location.search.substring(1));
                var parameters = parameterString.split("&");

                for (var index = 0; index < parameters.length; index++) {
                    var findErrorParameter = parameters[index].split("=");
                    if (findErrorParameter[0] === "errorCode") {
                        var errorCode = findErrorParameter[1];
                        break;
                    }
                }
                return errorCode;
            }

            function getCurrentLanguage() {
                var webLinkSettings = WebLink.info.getSettings();
                var selectedLanguage = webLinkSettings.language;
                if (selectedLanguage === "default") {
                    selectedLanguage = window.navigator.language;
                }
                return selectedLanguage;
            }

            function showErrorMessage() {
                var selectedLanguage = getCurrentLanguage();
                var xhr = new XMLHttpRequest();
                xhr.onreadystatechange = function () {
                    /*
                     Check for error code 0, because on iOS when making XMLHTTPRequests to a local file,
                     the received status is 0, regardless of the success of the request itself. I.e. even if the file is
                     not found, the status is 0.
                     */
                    if (this.readyState === 4 && (this.status === 200 || (this.status === 0 && this.responseText.length > 0))) {
                        var response = JSON.parse(xhr.responseText);
                        var errorCode = getErrorCode();
                        if (response[errorCode] === undefined) {
                            errorCode = DEFAULT_ERROR;
                        }
                        document.getElementById("errorMessage").innerText = response[errorCode];
                    } else if (this.readyState === 4 && (this.status > 399)) {
                        var selectedLanguage = DEFAULT_LANGUAGE;
                        var xhrDefaultLanguage = new XMLHttpRequest();
                        xhrDefaultLanguage.onreadystatechange = function () {
                            if (this.readyState === 4 && (this.status === 200 || this.status === 304)) {
                                var responseDefaultLanguage = JSON.parse(xhrDefaultLanguage.responseText);
                                var errorCodeDefaultLanguage = getErrorCode();
                                if (responseDefaultLanguage[errorCodeDefaultLanguage] === undefined) {
                                    errorCodeDefaultLanguage = DEFAULT_ERROR;
                                }
                                document.getElementById("errorMessage").innerText = responseDefaultLanguage[errorCodeDefaultLanguage];
                            }
                        };
                        xhrDefaultLanguage.open("GET", "./locales/" + selectedLanguage + ".json", true);
                        xhrDefaultLanguage.send();
                    }
                };
                xhr.open("GET", "./locales/" + selectedLanguage + ".json", true);
                xhr.send();
            }

            document.addEventListener(WL_LANGUAGE_CHANGE_EVENT_NAME, function (ev) {
               showErrorMessage();
            }, false);
                                            


            document.getElementById("backButtonLi").addEventListener("click", function () {
                window.location.href = "wlhome://"
            }, false);

            document.getElementById("homeButtonLi").addEventListener("click", function () {
                window.location.href = "wlhome://"
            }, false);

            showErrorMessage();
        }
    }, 200);
})();

    
