if (typeof (WebLink) === 'undefined') { WebLink = {}; }
if (typeof (WebLink.Audio) === 'undefined') { WebLink.Audio = {}; }

/*------------ Audio support */
if(typeof(Audio.prototype.original_play)==='undefined') {       
  Audio.prototype.original_play = Audio.prototype.play;
  /*support audio class*/
  Audio.prototype.play = function () {
    WebLink.currentAudio = this;
    WebLinkHostAudio.audioPlay(this.src);
  };
  /*support audio html tag*/
  Object.getPrototypeOf(document.createElement('audio')).play = Audio.prototype.play;                                                 
}
                                                               
if(typeof(Audio.prototype.original_pause)==='undefined') {      
  Audio.prototype.original_pause = Audio.prototype.pause;
  Audio.prototype.pause = function () {
    WebLinkHostAudio.audioPause();
  };
  Object.getPrototypeOf(document.createElement('audio')).pause = Audio.prototype.pause;                                                            
}                                                               

if(typeof(Audio.prototype.defined_duration)==='undefined') {      
  Audio.prototype.defined_duration = 'true';
  /* unlock duration property */
  Object.defineProperty(HTMLAudioElement.prototype, 'duration', {
    enumerable: false,
    configurable: false,
    writable: true,
    value: 0
  });                                                         
}

if(typeof(Audio.prototype.defined_currentTime)==='undefined') {      
  Audio.prototype.defined_currentTime = 'true';
  /* unlock currentTime property */
  /*console.log("====>  Object.defineProperty(HTMLAudioElement.prototype, 'currentTime',...); ");*/
  Object.defineProperty(HTMLAudioElement.prototype, 'currentTime', {
     enumerable: false,
     configurable: false,
     set: function(value) {
         /* console.log("====> currentTime set: " + value); */
         WebLinkHostAudio.audioSeek(value);
         this._currentTime = value;
     },
     get: function() {
         /* console.log("====> currentTime get: " + this._currentTime); */
         return this._currentTime;
     }
  });                                                         
}

if(typeof(Audio.prototype.defined_src)==='undefined') {
  Audio.prototype.defined_src = 'true';
  var proto = HTMLAudioElement.prototype;
  proto.original_set_src = proto.__lookupSetter__('src');
  proto.original_get_src = proto.__lookupGetter__('src');
  Object.defineProperty(proto, 'src', {
        get: function () {
            return this.original_get_src();
        },
        set: function (value) {
            this.original_set_src(value);
            /*if(!value || value.length == 0) {*/
                WebLinkHostAudio.audioStop();
            /*}*/
        }
     }
  );
}

if(typeof(Audio.prototype.defined_paused)==='undefined') {      
  Audio.prototype.defined_paused = 'true';
  /* unlock paused property */
  Object.defineProperty(HTMLAudioElement.prototype, 'paused', {
     enumerable: false,
     configurable: false,
     writable: true,
     value: true
  });                                                         
}

WebLink.onAudioEvent = function(name, errorCode, errorDescription) {
  /*console.log("====> onAudioEvent: " + name);*/
  if(WebLink.currentAudio  !== 'undefined') {
     var event = document.createEvent('Event');
     event.initEvent(name);
     if (name === 'playing') {
  	    WebLink.currentAudio.paused = false;
     }  else if (name === 'ended') {
  	    WebLink.currentAudio.paused = true;
     }  else if (name === 'pause') {
        WebLink.currentAudio.paused = true;
     }  else if (name === 'error') {
        event.error = {code: errorCode, description: errorDescription};
        WebLink.currentAudio.paused = true;
     }
     WebLink.currentAudio.dispatchEvent(event);
  } else {
     console.error("No current audio!");
  }
};

