(function () {
    function getAndroidVersion() {
        var ua = navigator.userAgent.toLowerCase();
        var match = ua.match(/android\s([0-9\.]*)/);
        return match ? match[1] : 0;
    };

    var androidVersion = parseFloat(getAndroidVersion());
    var viewportsMetaTags = document.querySelectorAll('[name=viewport]');
    var i = 0;
    for(i = 0; i < viewportsMetaTags.length; i++) {
        viewportsMetaTags[i].parentElement.removeChild(viewportsMetaTags[i]);
    }
    var meta = document.createElement('meta');
    meta.id = 'viewport';
    meta.name='viewport';
    meta.content = 'width=%d, height=%d, user-scalable=no';
    document.getElementsByTagName('head')[0].appendChild(meta);

    /*prevents horizontal scroll in Android 7+*/
    if(androidVersion >= 7) {
         var content = meta.getAttribute('content');
         var arr = content.split(',');
         arr.forEach(function (property, index) {
             if (property.indexOf('width') >= 0) {
                 var width = arr[index].split('=');
                 width[1] = window.innerWidth;
                 arr[index] = width.join('=');
                 content = arr.join(',');
                 meta.setAttribute('content', content);
             }
         });
    }
})();