if (typeof (WebLink) === 'undefined') { WebLink = {}; }
if (typeof (WebLink.tts) === 'undefined') { WebLink.tts = {}; }
if (typeof (WebLink.tts.voiceList) === 'undefined') { WebLink.tts.voiceList = []; }

if (typeof (WebLink.tts.addVoice) === 'undefined') {
  WebLink.tts.addVoice = function(voice) {
  	WebLink.tts.voiceList.push(voice);
  };
}

if (typeof (WebLink.tts.clearVoices) === 'undefined') {
  WebLink.tts.clearVoices = function() {
  	WebLink.tts.voiceList = [];
  };
}

window.speechSynthesis = {};
window.speechSynthesis.pending = false;
window.speechSynthesis.speaking = false;
window.speechSynthesis.paused = false;

if (typeof WebLink.tts.onTTSEvent  === 'undefined') {
  WebLink.tts.onTTSEvent = function(eventName) {
  	if(WebLink.tts.currentUtterance && typeof WebLink.tts.currentUtterance[eventName] == "function") {
		WebLink.tts.currentUtterance[eventName].apply(WebLink.tts.currentUtterance, []);
	}
  };
}

window.speechSynthesis.speak = function(utterance) {
  console.log("===> window.speechSynthesis.speak");
  var text = "";
  if (typeof utterance.text !== 'undefined') {
  	text = utterance.text;
  }
  WebLink.tts.currentUtterance = utterance;
  WebLinkHostTTS.ttsSpeak(text);
};

window.speechSynthesis.cancel = function() {
  console.log("===> window.speechSynthesis.cancel");
  WebLinkHostTTS.ttsCancel();
  WebLink.tts.currentUtterance = null;
};

window.speechSynthesis.pause = function() {
  console.log("===> window.speechSynthesis.pause");
  WebLinkHostTTS.ttsPause();
};

window.speechSynthesis.resume = function() {
  console.log("===> window.speechSynthesis.resume");
  WebLinkHostTTS.ttsResume();
};

window.speechSynthesis.getVoices = function() {
  console.log("===> window.speechSynthesis.getVoices length: " + WebLink.tts.voiceList.length);
  return WebLink.tts.voiceList;
};

window.SpeechSynthesisUtterance = function(paramText) {
  this.text = paramText;
  this.lang = '';
  this.onboundary = null;
  this.onend = null;
  this.onerror = null;
  this.onmark = null;
  this.onpause = null;
  this.onresume = null;
  this.onstart = null;
  this.pitch = 1;
  this.rate = 1;
  this.voice = null;
  this.volume = 1;
};

SpeechSynthesisUtterance = window.SpeechSynthesisUtterance;

