if (typeof (WebLink) === 'undefined') { WebLink = {}; }

/*------------ Cross origin HTTP requests support*/
WebLink.enableCrossOriginRequests = function() {
  WebLink.isCrossOrigin = function(url) {
    var location = window.location;
    var a = document.createElement('a');
    a.href = url;
    var result =
      a.hostname  != location.hostname  ||
      a.port      != location.port      ||
      a.protocol  != location.protocol;
    return result;
  };
  if(typeof(XMLHttpRequest_original) === 'undefined') {
    XMLHttpRequest_original = XMLHttpRequest;
  }
  XMLHttpRequest = function() {
    this.ID = ++XMLHttpRequest.lastID;
    XMLHttpRequest.requestsList[this.ID] = this;
  };
  XMLHttpRequest.requestsList = {};
  XMLHttpRequest.lastID = -1;
  XMLHttpRequest.UNSENT            = 0;
  XMLHttpRequest.OPENED            = 1;
  XMLHttpRequest.HEADERS_RECEIVED  = 2;
  XMLHttpRequest.LOADING           = 3;
  XMLHttpRequest.DONE              = 4;
  XMLHttpRequest.prototype.UNSENT            = XMLHttpRequest.UNSENT;
  XMLHttpRequest.prototype.OPENED            = XMLHttpRequest.OPENED;
  XMLHttpRequest.prototype.HEADERS_RECEIVED  = XMLHttpRequest.HEADERS_RECEIVED;
  XMLHttpRequest.prototype.LOADING           = XMLHttpRequest.LOADING;
  XMLHttpRequest.prototype.DONE              = XMLHttpRequest.DONE;
  XMLHttpRequest.prototype.readyState        = XMLHttpRequest.UNSENT;
  XMLHttpRequest.prototype.responseText  = '';
  XMLHttpRequest.prototype.responseXML   = null;
  XMLHttpRequest.prototype.status        = 0;
  XMLHttpRequest.prototype.statusText    = '';
  XMLHttpRequest.prototype.onreadystatechange  = null;
  XMLHttpRequest.prototype.isCrossOrigin = false;
  XMLHttpRequest.prototype.open = function(method, url, async, user, password) {
    this.isCrossOrigin = WebLink.isCrossOrigin(url);
    WebLinkHostHttpRequest.openRequest(this.ID, method, url);
  };
  XMLHttpRequest.prototype.setRequestHeader = function(header, value) {
    WebLinkHostHttpRequest.setRequestHeader(this.ID, header, value);
  };
  XMLHttpRequest.prototype.send = function(data) {
    var dataString = (typeof(data) !== 'undefined' && data != null) ?
      JSON.stringify(data) : '';
    WebLinkHostHttpRequest.sendRequest(this.ID, dataString);
  };
  XMLHttpRequest.prototype.abort = function() {
    WebLinkHostHttpRequest.abortRequest(this.ID);
  };
  XMLHttpRequest.prototype.getAllResponseHeaders = function() {
    return this._responseHeaders;
  };
  XMLHttpRequest.prototype.getResponseHeader = function(header) {
    return this._responseHeaders[header];
  };
};
