if (typeof (WebLink) === 'undefined') {
	WebLink = {};
}
if (typeof (WebLink.notifications) === 'undefined') {
	WebLink.notifications = {}; 
}
if (typeof (WebLink.notifications.NotificationList) === 'undefined') {
	WebLink.notifications.NotificationList = {}; 
}


if (typeof (WebLink.notifications.findNotification)  === 'undefined') {
    WebLink.notifications.findNotification = function(notificationID) {
  	    if(WebLink.notifications.NotificationList) {
  	        var obj = WebLink.notifications.NotificationList[notificationID];
  	        if(typeof(obj) === 'object' && obj && obj.internalID && obj.internalID === notificationID) {
  	            return obj;
  	        }
  	    } 
    
        return null;
    };
}

if (typeof (WebLink.notifications.onNotificationEvent)  === 'undefined') {
    WebLink.notifications.onNotificationEvent = function(eventName, notificationID) {
  	    var not = WebLink.notifications.findNotification(notificationID - 0);
  	    if(not && typeof(not[eventName]) === 'function') {
  	    	not[eventName].apply(not, []);
  	    	
  	    	/* Close the notification */
  	    	if('onclose' === eventName || 'onerror' === eventName) { /* TODO: maybe also close upon onclick()??? */
  	    	    WebLink.notifications.NotificationList[notificationID - 0] = null;
  	    	}
  	    }
    };
}

if (typeof (WebLink.notifications.closeNotification)  === 'undefined') {
    WebLink.notifications.closeNotification = function(notificationID) {
        var not = WebLink.notifications.findNotification(notificationID - 0);
        if(not) {
            NotificationsJSPlugin.closeNotification(notificationID - 0);
        }
    };
}

if (typeof (WebLink.notifications.qualifyURL)  === 'undefined') {
    WebLink.notifications.qualifyURL = function(url) {
        var a = document.createElement('a');
        a.href = url;
        var res = a.href;
        return res;
    };
}

if (typeof (WebLink.notifications.printURL)  === 'undefined') {
    console.log('.  8');
    WebLink.notifications.printURL = function(url) {
        var res = WebLink.notifications.qualifyURL(url);
        console.log(res);
    };
}

if (typeof (WebLink.notifications.toNotNullString)  === 'undefined') {
    WebLink.notifications.toNotNullString = function(str) {
        var res = '';
        if(typeof (str) === 'undefined' || (typeof (str) === 'object' && !str)) {
            res = '';
        } else {
            res = '' + str;
        }
        return res;
    };
}


/************************************************
** Replace the HTML 5 Notifications
************************************************/
window.Notification = function (title, options) {
    /* Construct the notification object */ 
    this.title = title;
    this.dir = 'auto';
    this.lang = '';
    this.body = '';
    this.tag = '';
    this.icon = '';
    this.timeout = 0;
    this.showProgress = false;
    
    /* Copy the options */
    if (!!options) {
        if (!!options.dir) {
            this.dir = options.dir;
        }
        
        this.lang = WebLink.notifications.toNotNullString(options.lang);
        this.body = WebLink.notifications.toNotNullString(options.body);
        this.tag = WebLink.notifications.toNotNullString(options.tag);
        this.icon = WebLink.notifications.toNotNullString(options.icon);
        
        if(typeof options.timeout === 'number' && options.timeout > 0) {
            var intvalue = Math.round( options.timeout );
            this.timeout = intvalue;
        } else {
            this.timeout = 0;
        }
        
        if(typeof options.showProgress === 'boolean') {
            this.showProgress = options.showProgress;
        }
    }

	var icon = this.icon;
	if(icon.length > 0) {
	    icon = WebLink.notifications.qualifyURL(icon);
	}

    var id = NotificationsJSPlugin.addNotification(title, icon, this.tag, this.timeout, this.showProgress);
    this.internalID = id;
    WebLink.notifications.NotificationList[id] = this;
    
    this.close = function () {
    	WebLink.notifications.closeNotification(this.internalID);
    };
};

window.Notification.permission = 'granted';
window.Notification.requestPermission = function (callback) {
    /* We always allow notifications. */
    if (typeof callback === 'function') {
        /* Notify asynchronously */
        setTimeout(function () {
            callback('granted');
        }, 1);
    }
};

Notification = window.Notification;
