
if (typeof (WebLink) === 'undefined') {
	WebLink = {};
}
if (typeof (WebLink.speechrecognition) === 'undefined') {
	WebLink.speechrecognition = {}; 
}

WebLink.speechrecognition.currentSpeechRecognition = undefined;

WebLink.speechrecognition.onError = function(error, message) {
	console.log('WebLink.speechrecognition.onError');
	WebLink.speechrecognition.lastError = error;
	WebLink.speechrecognition.lastMessage = message;
	if(WebLink.speechrecognition.currentSpeechRecognition) {
		var recognition = WebLink.speechrecognition.currentSpeechRecognition;
		WebLink.speechrecognition.currentSpeechRecognition = undefined;
		recognition._onError(error, message);
	}
};

WebLink.speechrecognition.onResult = function(result) {
	console.log('WebLink.speechrecognition.onResult');
	WebLink.speechrecognition.lastResult = result;
	console.log(result);
	if(WebLink.speechrecognition.currentSpeechRecognition) {
		console.log('The currentSpeechRecognition exists');
		var recognition = WebLink.speechrecognition.currentSpeechRecognition;
		WebLink.speechrecognition.currentSpeechRecognition = undefined;
		recognition._onResult(result);
	}
};

/*

WebLink.speechrecognition.onError = function(error, message) {
	console.log('WebLink.speechrecognition.onError');
	WebLink.speechrecognition.lastError = error;
	WebLink.speechrecognition.lastMessage = message;
};

WebLink.speechrecognition.onResult = function(result) {
	console.log('WebLink.speechrecognition.onResult');
	WebLink.speechrecognition.lastResult = result;
};

*/



/************************************************
** Replace the HTML 5 SpeechRecognition
************************************************/
window.SpeechRecognition = function () {
    /* Construct the notification object */ 
    this.continuous = false;
	this.lang = "";
	this.grammars = [];
	this.interimResults = false;
	this.maxAlternatives = 1;
	this.serviceURI = undefined; /* Not used! */
	
    this.onaudiostart = undefined;
    this.onsoundstart = undefined;
    this.onspeechstart = undefined;
    this.onspeechend = undefined;
    this.onsoundend = undefined;
    this.onaudioend = undefined;
    this.onresult = undefined;
    this.onnomatch = undefined;
    this.onerror = undefined;
    this.onstart = undefined;
    this.onend = undefined;
    
    this._onError = function(err, msg) {
			if(this.onerror && typeof(this.onerror) === 'function') {
				var e = { error: err, message: msg };
				try {
					this.onerror(e);
				} catch(err1) {
					console.log("Error in onerror()");
					console.log(err1);
				}
			}
			if(this.onend && typeof(this.onend) === 'function') {
				try {
					this.onend();
				} catch(err2) {
					console.log("Error in onend()");
					console.log(err2);
				}
			}
	};
	
	this._onResult = function(result) {
		if(this.onresult && typeof(this.onresult) === 'function') {
			var obj = "";
			try {
				obj = eval(result);
			} catch(err1) {
				console.log("Error in eval()");
				console.log(err1);
			}
			try {
				this.onresult(obj);
			} catch(err2) {
				console.log("Error in onresult()");
				console.log(err2);
			}
		}
		if(this.onend && typeof(this.onend) === 'function') {
			this.onend();
		}
	};
	
	this.start = function() {
		if(WebLink.speechrecognition.currentSpeechRecognition) {
			/* this is an error, let's wait for the other SR to finish! */
			this._onError("service-not-allowed", "Another Speech Recognition is ongoing!");
			return;
		}
		
		WebLink.speechrecognition.currentSpeechRecognition = this;
		SpeechRecognitionPlugin.startSpeechRecognition(this.maxAlternatives - 0);
	};
	
	this.stop = function() {
		if(WebLink.speechrecognition.currentSpeechRecognition != this) {
			/* This is an error */
			return;
		}
		
		this._onError("aborted", "aborted");
		
		SpeechRecognitionPlugin.stopSpeechRecognition();
	};
	
	this.abort = function() {
		this.stop();
	};
};

SpeechRecognition = window.SpeechRecognition;

console.log('SpeechRecognition injected');
