console.log("Keyboard inject");

if (typeof (WebLink) === 'undefined') { WebLink = {}; }
if (typeof (WebLink.appManager) === 'undefined') { WebLink.appManager = {}; }

/*------------ Keyboard support*/
WebLink.inputTypes = ['email', 'number', 'password', 'search', 'tel', 'text',  'url'];
WebLink.keyboardInput = null;

WebLink.checkElementForKeyboardInput = function(element) {
  if(element != null) {
	console.log(element.nodeName.toLowerCase());
  }
  if(element != null && ( (element.nodeName.toLowerCase() === 'input'  && this.inputTypes.indexOf(element.type) != -1) || element.nodeName.toLowerCase() === 'textarea')) {
    WebLink.keyboardInput = element;
    element.readOnly = true;
    WLJSManager.showKeyboard(element.type, WebLink.GetBoundingClientRectZoomed(element).bottom, WebLink.keyboardInput.value);
  }
  else {
    WLJSManager.hideKeyboard();
  }
};

WebLink.setKeyboardText = function(text) {
  if (WebLink.keyboardInput)
  {
  	WebLink.keyboardInput.value = text;
    
    /*
     *  A fix for Angular; 
     *  also other code may depend on notifications for changed value of an input
     */
    var evt = document.createEvent("HTMLEvents");
	evt.initEvent("input", false, true);
	WebLink.keyboardInput.dispatchEvent(evt);
  }
};


WebLink.jsTouchAndKeyboard = true;
WebLink.eventTypes = WebLink.eventTypes || {
  'touch': ['touchstart', 'touchmove', 'touchend'],
  'mouse': ['mousedown', 'mousemove', 'mouseup', 'mouseover', 'mouseout', 'click']
};
WebLink.inputTypes = WebLink.inputTypes || ['email', 'number', 'password', 'search', 'tel', 'text',  'url'];
WebLink.keyboardInput = null;
WebLink.showKeyboard = false;
WebLink.hideKeyboard = false;
WebLink.RecursiveFindPosition = WebLink.RecursiveFindPosition || function(element) {
  if(element){
    var total = WebLink.RecursiveFindPosition(element.offsetParent);
    var zoom = window.getComputedStyle(element)["zoom"];
    if(!zoom) zoom = 1.0;
    total.zoom *= zoom;
    total.left += total.zoom*(element.offsetLeft - element.scrollLeft + element.clientLeft);
    total.top += total.zoom*(element.offsetTop - element.scrollTop + element.clientTop);
    return total;
  }
  return {left:0,top:0,zoom:1.0};
};
WebLink.GetBoundingClientRectZoomed = WebLink.GetBoundingClientRectZoomed || function(element){
	var baseRect = element.getBoundingClientRect();
	var result = WebLink.RecursiveFindPosition(element);
	result.width = baseRect.width*result.zoom;
	result.height = baseRect.height*result.zoom;
	result.right = result.left+result.width;
	result.bottom = result.top+result.height;
	return result;
};

if (window.onClickListenerAdded === undefined) {
    window.onClickListenerAdded = true;
    document.addEventListener('click', function(event) {
      console.log(event);
      console.log(event.target);
      WebLink.checkElementForKeyboardInput(event.target);
    });
}


console.log("Keyboard injected");
