if (typeof (WebLink) === 'undefined') {
    WebLink = {};
}
if (typeof (WebLink.youtubePlugin) === 'undefined') {
    WebLink.youtubePlugin = {};
}

if (typeof (WebLink.youtubePlugin.getToken) === 'undefined') {
    WebLink.youtubePlugin.getToken = function () {
       return new Promise(function (resolve, reject) {
           youtubePlugin.getToken(
               WebLink.callbackManager.save(this, function (newToken) {
                   resolve(newToken);
               }),
               WebLink.callbackManager.save(this, function (error) {
                   reject(JSON.parse(error));
               }));
       })
    };
}

if (typeof (WebLink.youtubePlugin.getCachedToken) === 'undefined') {
    WebLink.youtubePlugin.getCachedToken = function () {
       return new Promise(function (resolve, reject) {
           youtubePlugin.getCachedToken(
               WebLink.callbackManager.save(this, function (newToken) {
                   resolve(newToken);
               }),
               WebLink.callbackManager.save(this, function (error) {
                   reject(JSON.parse(error));
               }));
       })
    };
}

if (typeof (WebLink.youtubePlugin.getUserName) === 'undefined') {
    WebLink.youtubePlugin.getUserName = function() {
        return youtubePlugin.getUserName();
    };
}

if (typeof (WebLink.youtubePlugin.logOut) === 'undefined') {
    WebLink.youtubePlugin.logOut = function() {
        return youtubePlugin.logOut();
    };
}

if (!('onChangeLoginState' in WebLink.youtubePlugin)) {
    Object.defineProperty(WebLink.youtubePlugin, 'onChangeLoginState', {
        set: function (value) {
            if (typeof value !== 'function') {
                throw new Error('onChangeLoginState should be a function!');
            }
            WebLink.youtubePlugin._onChangeLoginState = value;
        },
        get: function () {
            return WebLink.youtubePlugin._onChangeLoginState;
        },
    });
}
